//----------------------------------------------------------------------//
// K\`FbJ[													//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <System.StrUtils.hpp>
#include <RegularExpressions.hpp>
#include <Vcl.Clipbrd.hpp>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "RegExChk.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRegExChecker *RegExChecker = NULL;

//---------------------------------------------------------------------------
__fastcall TRegExChecker::TRegExChecker(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::FormCreate(TObject *Sender)
{
	//K\̐ݒ
	TStringList *lst = UserModule->RefRegExList;
	for (int i=0; i<lst->Count; i++) {
		UnicodeString lbuf = lst->Strings[i];
		if (!lbuf.IsEmpty()) MemoListBox->Items->Add((lbuf[1]=='-')? EmptyStr : lbuf);
	}
	//Tvǉ
	std::unique_ptr<TStringList> s_lst(new TStringList());
	s_lst->Text =
		"\n\ny Tv z\n"
		"t\t[12]\\d{3}/(0?[1-9]|1[0-2])/([12][0-9]|3[01]|0?[1-9])\n"
		"\t([01]?[0-9]|2[0-3])(:[0-5][0-9]){1,2}\n"
		"URL\thttps?://[\\w/:%#$&?()~.=+-]+\n"
		"\t\\d*[02468]\n"
		"\t\\d*[13579]\n"
		"Sp\t[^ -~-\\t]+\n"
		"p\t[-]+";

	MemoListBox->Items->AddStrings(s_lst.get());

	PtnComboBox->Tag = CBTAG_HISTORY;

	ObjComboBox    = NULL;
	ObjLabeledEdit = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	TStringDynArray ibuf = get_csv_array(IniFile->ReadStrGen(_T("RegExChkText"), EmptyStr, false), 20);
	ObjMemo->Clear();
	for (int i=0; i<ibuf.Length; i++) ObjMemo->Lines->Add(ibuf[i]);

	ResPanel->Height	   = IniFile->ReadIntGen(_T("RegExResHeight"),	150);
	MemoPanel->Width	   = IniFile->ReadIntGen(_T("RegExRefWidth"),	240);
	ReplaceEdit->Text	   = IniFile->ReadStrGen(_T("RegExChkRepStr"));
	CaseCheckBox->Checked  = IniFile->ReadBoolGen(_T("RegExChkCase"),	false);
	MltLnCheckBox->Checked = IniFile->ReadBoolGen(_T("RegExChkMltLn"),	true);

	IniFile->LoadComboBoxItems(PtnComboBox, _T("RegExChkHistory"));
	if (PtnComboBox->Items->Count>0) PtnComboBox->ItemIndex = 0;
	if (!PatternStr.IsEmpty()) PtnComboBox->Text = PatternStr;

	PtnSelStart  = PtnComboBox->SelStart;
	PtnSelLength = PtnComboBox->SelLength;

	ResultLabel->Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::FormClose(TObject *Sender, TCloseAction &Action)
{
	ObjComboBox    = NULL;
	ObjLabeledEdit = NULL;
	PatternStr	   = EmptyStr;

	IniFile->SavePosInfo(this);

	UnicodeString lbuf;
	for (int i=0; i<ObjMemo->Lines->Count && i<20; i++) {
		if (i>0) lbuf.UCAT_T(",");
		lbuf += make_csv_str(ObjMemo->Lines->Strings[i]);
	}
	IniFile->WriteStrGen(_T("RegExChkText"),	lbuf);

	IniFile->WriteIntGen(_T("RegExResHeight"),	ResPanel->Height);
	IniFile->WriteIntGen(_T("RegExRefWidth"),	MemoPanel->Width);
	IniFile->WriteStrGen(_T("RegExChkRepStr"),	ReplaceEdit->Text);
	IniFile->WriteBoolGen(_T("RegExChkCase"),	CaseCheckBox->Checked);
	IniFile->WriteBoolGen(_T("RegExChkMltLn"),	MltLnCheckBox->Checked);
	IniFile->SaveComboBoxItems(PtnComboBox, _T("RegExChkHistory"));
}
//---------------------------------------------------------------------------
//eXg
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::TestActionExecute(TObject *Sender)
{
	try {
		ResListBox->Clear();

		UnicodeString ptnstr = PtnComboBox->Text;
		TRegExOptions opt;
		if (!CaseCheckBox->Checked) opt<<roIgnoreCase;
		if (MltLnCheckBox->Checked) {
			for (int i=0; i<ObjMemo->Lines->Count; i++) {
				TMatchCollection mts = TRegEx::Matches(ObjMemo->Lines->Strings[i], ptnstr, opt);
				for (int j=0; j<mts.Count; j++) ResListBox->Items->Add(mts.Item[j].Value);
			}
		}
		else {
			TMatchCollection mts = TRegEx::Matches(ObjMemo->Lines->Text, ptnstr, opt);
			for (int i=0; i<mts.Count; i++) ResListBox->Items->Add(mts.Item[i].Value);
		}

		//
		if (ResListBox->Count>0) {
			add_ComboBox_history(PtnComboBox);
			ResultLabel->Caption = "}b`܂";
			ResultLabel->Font->Color = scl_WindowText;;
		}
		else {
			ResultLabel->Caption = "}b`܂";
			ResultLabel->Font->Color = col_Error;
			beep_Warn();
		}
	}
	catch (...) {
		ResultLabel->Caption = "s܂";
		ResultLabel->Font->Color = col_Error;
		beep_Warn();
	}
}
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::TestActionUpdate(TObject *Sender)
{
	bool reg_ok = chk_RegExPtn(PtnComboBox->Text);
	PtnComboBox->Color = (PtnComboBox->Text.IsEmpty() || reg_ok)? scl_Window: col_Illegal;
	((TAction *)Sender)->Enabled = !ObjMemo->Lines->Text.IsEmpty() && reg_ok;

	if (PtnComboBox->Focused()) {
		PtnSelStart  = PtnComboBox->SelStart;
		PtnSelLength = PtnComboBox->SelLength;
	}
}
//---------------------------------------------------------------------------
//u
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::ReplaceActionExecute(TObject *Sender)
{
	try {
		ResListBox->Clear();

		UnicodeString ptnstr = PtnComboBox->Text;
		TRegExOptions opt;
		if (!CaseCheckBox->Checked) opt<<roIgnoreCase;
		if (MltLnCheckBox->Checked) {
			for (int i=0; i<ObjMemo->Lines->Count; i++) {
				UnicodeString lbuf = ObjMemo->Lines->Strings[i];
				TMatchCollection mts = TRegEx::Matches(lbuf, ptnstr, opt);
				if (mts.Count>0)
					ResListBox->Items->Add(TRegEx::Replace(lbuf, ptnstr, ReplaceEdit->Text, opt));
			}
		}
		else {
			std::unique_ptr<TStringList> rlst(new TStringList());
			rlst->Text = TRegEx::Replace(ObjMemo->Lines->Text, ptnstr, ReplaceEdit->Text, opt);
			ResListBox->Items->Assign(rlst.get());
		}

		//
		if (ResListBox->Count>0) {
			ResultLabel->Caption = "u܂";
			ResultLabel->Font->Color = scl_WindowText;;
		}
	}
	catch (...) {
		ResultLabel->Caption = "s܂";
		ResultLabel->Font->Color = col_Error;
		beep_Warn();
	}
}
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::ReplaceActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = TestAction->Enabled;
}

//---------------------------------------------------------------------------
//\t
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::PasteActionExecute(TObject *Sender)
{
	if		(ObjComboBox)	 ObjComboBox->Text	  = PtnComboBox->Text;
	else if (ObjLabeledEdit) ObjLabeledEdit->Text = "/" + PtnComboBox->Text + "/";
}
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::PasteActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !PtnComboBox->Text.IsEmpty() && (ObjComboBox || ObjLabeledEdit);
}

//---------------------------------------------------------------------------
//Rs[
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::CopyActionExecute(TObject *Sender)
{
	UnicodeString ptn = PtnComboBox->Text;
	if (((TAction*)Sender)->Tag==1) ptn = "\"" + ReplaceStr(ptn, "\\", "\\\\") + "\"";

	Clipboard()->AsText = ptn;
}
//---------------------------------------------------------------------------
void __fastcall TRegExChecker::CopyActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !PtnComboBox->Text.IsEmpty();
}

//---------------------------------------------------------------------------
void __fastcall TRegExChecker::MemoListBoxDblClick(TObject *Sender)
{
	TListBox *lp = (TListBox *)Sender;
	int idx = lp->ItemIndex;
	if (idx!=-1) {
		UnicodeString s = lp->Items->Strings[idx];
		if (s.Pos("\t")) {
			s = (idx<UserModule->RefRegExList->Count)? get_pre_tab(s) : get_post_tab(s);
			PtnComboBox->SetFocus();
			PtnComboBox->SelStart  = PtnSelStart;
			PtnComboBox->SelLength = PtnSelLength;
			PtnComboBox->SelText   = s;
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TRegExChecker::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}
//---------------------------------------------------------------------------

